package cz.frantovo.nekurak.ejb;

import cz.frantovo.nekurak.dao.PodnikDAO;
import cz.frantovo.nekurak.dto.Podnik;
import java.util.Collection;
import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.ejb.EJB;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;

/**
 *
 * @author fiki
 */
@Stateless
public class PodnikEJB implements PodnikRemote {

    @EJB
    private PodnikDAO podnikDAO;
    @Resource
    private SessionContext ctx;

    public Collection<Podnik> getPodniky() {
	Collection<Podnik> vysledek = podnikDAO.getPodniky();

	for (Podnik p : vysledek) {
	    System.out.println("FOTKY:" + p.getFotky());
	}


	return vysledek;
    }

    @RolesAllowed("opravneny")
    public void zalozPodnik(Podnik p) {
	p.setSpravce(ctx.getCallerPrincipal().getName());
	podnikDAO.zaloz(p);
    }

    @RolesAllowed("opravneny")
    public void upravPodnik(Podnik p) {
	podnikDAO.uloz(p);
    }
}
