package cz.frantovo.nekurak.ejb;

import cz.frantovo.nekurak.dao.UzivatelDAO;
import cz.frantovo.nekurak.dto.PozadavekNaRegistraciUzivatele;
import cz.frantovo.nekurak.dto.Uzivatel;
import cz.frantovo.nekurak.util.Hash;
import cz.frantovo.nekurak.vyjimky.NecekanaVyjimka;
import cz.frantovo.nekurak.vyjimky.NekurakVyjimka;
import java.io.UnsupportedEncodingException;
import java.security.NoSuchAlgorithmException;
import javax.ejb.EJB;
import javax.ejb.Stateless;

/**
 *
 * @author fiki
 */
@Stateless
public class UzivatelEJB implements UzivatelRemote {

    @EJB
    private UzivatelDAO uzivatelDao;

    /** Uživatele může zakládat kdokoli – uživatel se registruje sám. */
    public void registrujUzivatele(PozadavekNaRegistraciUzivatele p) throws NekurakVyjimka {
	try {
	    Uzivatel u = p.getUzivatel();
	    /** Heslo musíme před uložení zahashovat, aby se uživatel mohl přihlásit. */
	    u.setHeslo(Hash.hashuj(u.getHeslo()));
	    uzivatelDao.zaloz(u);
	} catch (NoSuchAlgorithmException e) {
	    /** Nemělo by nastat */
	    throw new NecekanaVyjimka("Neexistující hashovací algoritmus.", e);
	} catch (UnsupportedEncodingException e) {
	    /** Nemělo by nastat */
	    throw new NecekanaVyjimka("Nepodporované kódování znaků.", e);
	}
    }
}
